#define CT_DELIMIT 2
#define CT_QUOTE   3
#define TT_EOF    -1	// The End-of-file token.
#define TT_WORD   -2	// The word token.	This value is in sval.

class CStreamTokenizer : public Cobject {
private:
	static char	*m_ctypeP;

	FILE		*m_F;
	const char	*m_filenameP;
	int			m_peekc;		// Will appear to be first character but ignored so ok
	int			m_pushedBack;	// True if last token pushed back to be reconsumed on next call
	int			m_escaped;

	/* TODO: Thinks about a more memory efficient -- extensible method perhaps by using StringBuffer 
	         Also try to make this static by changing how include is implemented
	 */

	int			m_buf_size;
	char		*m_bufP;		// The area that captures a token or attribute value

	/**
	 * The type of the last token returned when m_pushBack is true.	 It's value will either
	 * be one of the following TT_* constants, or a single character.  For example, if '+' is
	 * encountered and is not a valid word character, ttype will be '+'
	 */

	int			m_ttype;

	void	dumpBuf(int lth);
	int		enlargeBuffer();
	const char	*getString(int pos);
	int		charToken();
	int		charAVI();
			
protected:

	/**
	 * The Stream value.
	 */
	
	const char	*m_svalP;
	int			m_lineno;


	/** Does an unget of the last token */

	void pushBack(int ttype); 

public:

//	private TA_IncludeStack m_stack = null;

	CStreamTokenizer(void); 
	void		open(const char *filenameP);
	const char *filename();
	int			lineno(); 

	/**
	 * Parses a token from the input stream.  The return value is
	 * the same as the value of ttype.	Typical clients of this
	 * class first set up the syntax tables and then sit in a loop
	 * calling nextToken to parse successive tokens until TT_EOF
	 * is returned.
	 */

	int			nextToken(); 
	const char *nextAVI(); 
	void		close();
};
